unit euroform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    InputEdit: TEdit;
    ConvertButton: TButton;
    ValutaRadioG: TRadioGroup;
    EuroLabel: TLabel;
    BEFLabel: TLabel;
    NLGLabel: TLabel;
    procedure ConvertButtonClick(Sender: TObject);
    procedure ValutaRadioGClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure InputEditKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    procedure ValutaConvert;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ConvertButtonClick(Sender: TObject);
begin
  ValutaConvert;
end;

procedure TForm1.ValutaRadioGClick(Sender: TObject);
begin
  ValutaConvert;
end;

{ Conversie naar Euro van de waarde in InputEdit,
  afhankelijk van de radiobutton die in ValutaRadioG
  geselecteerd is. Daarna conversie van Euro naar
  andere de valuta                                   }
procedure TForm1.ValutaConvert;
var
  StartBedrag, Euro, BEF, NLG: real;
  S1, S2, S3: string;
begin
  // Converteer tekst van de EDIT naar een numerieke waarde
  StartBedrag := StrToFloat(InputEdit.Text);

  // Bereken bedrag in Euro
  if ValutaRadioG.ItemIndex = 0 then // eerste button: Euro
    Euro := StartBedrag
  else
    if ValutaRadioG.ItemIndex = 1 then // tweede button: BEF
      Euro := StartBedrag / 40.3399
    else                              // derde button: NLG
      Euro := StartBedrag / 2.20371;

  //Converteer naar andere valuta
  BEF := Euro * 40.3399;
  NLG := Euro * 2.20371;

  { Converteer de floating point getallen naar string-formaat.
    '0.00' is de "Format String" en betekent:
    'geef het resultaat met 2 cijfers na de komma'            }
  S1 := FormatFloat('0.00', Euro);
  S2 := FormatFloat('0.00', BEF);
  S3 := FormatFloat('0.00', NLG);

  { Plaats de strings in de CAPTION van de LABELs
    en laat volgen door de munteenheid. Vul aan
    met spaties, zodat alles even lang wordt.     }
  EuroLabel.Caption := S1 + ' Euro   ';
  BEFLabel.Caption  := S2 + ' BEF/LUF';
  NLGLabel.Caption  := S3 + ' NLG    ';

  { Maak het label onzichtbaar dat overeenstemt
    met de start-munteenheid                    }
  EuroLabel.Visible := (ValutaRadioG.ItemIndex <> 0);
  BEFLabel.Visible := (ValutaRadioG.ItemIndex <> 1);
  NLGLabel.Visible := (ValutaRadioG.ItemIndex <> 2);
end;

{ Deze event handler wordt slechts eenmaal uitgevoerd,
  namelijk bij de start van het programma.
  Hier regelen we de eerste "automatische" conversie  }
procedure TForm1.FormCreate(Sender: TObject);
begin
  ValutaConvert;
end;

{ Wanneer InputEdit de focus heeft en wanneer op ENTER gedrukt
  wordt, doen we ook een conversie                             }
procedure TForm1.InputEditKeyPress(Sender: TObject; var Key: Char);
begin
  // 13 is de code voor de ENTER toets
  if Key = #13 then ValutaConvert;
end;

end.
